% Function to find local minima
% It returns that local minimum witht the smallest x 

%function main
% ---------------
% Testing routine
% ---------------
%clear all;
%clc;

%x = linspace(0,10,101);
%y = -(x-2).^2;
%figure(1); clf; hold on;
%plot(x,y);

%[x_min,ind_min,found] = find_local_minimum_with_smallest_x(y,x)

%if found == 1
%    plot(x_min,y(ind_min),'ro')
%end

%return


function [x_min,ind_min,found] = find_local_minimum_with_smallest_x(f,x)

% ------ estimation of first derivative ----
f_abl = abl_1_non_aequi(f,x);
% -------------------------------------------


signs = sign(f_abl);
sign_old = signs(1);


%figure(10); clf; hold on;
%plot(signs);
%pause(1);

counter = 0;

for i = 2:length(signs)
    
    sign_new = signs(i);
    
    if (sign_new ~= sign_old) & (sign_old == -1)  
        
        counter = counter + 1 ;
        x_min_vec(counter) = x(i); 
        index_vec(counter) = i;
        
    end
    
    sign_old = sign_new;   
    
end

if counter >= 1
    [x_min,ind] = min(x_min_vec);
    [x_min,ind] = max(x_min_vec);
    ind_min = index_vec(ind);
    found = 1;
else
    x_min = NaN;
    ind_min = [];
    found = 0;
end

return